summaryrefslogtreecommitdiffstats
path: root/package
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2007-03-02 01:23:36 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2007-03-02 01:23:36 +0000
commit1ebe6d34880d1e26b37fe4f794b5039a8245e750 (patch)
treec94b490dfda5ac1250f15663f2b17eeeb3924990 /package
parent9bf71c00ca3afbd968f782da24b16dbb00b2326e (diff)
make squashfs overlay support more generic and integrate it for x86-2.6
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@6450 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package')
-rw-r--r--package/base-files/Makefile7
-rwxr-xr-xpackage/base-files/files/bin/firstboot128
-rwxr-xr-xpackage/base-files/files/etc/preinit5
-rwxr-xr-xpackage/base-files/files/sbin/mount_root15
4 files changed, 153 insertions, 2 deletions
diff --git a/package/base-files/Makefile b/package/base-files/Makefile
index 33e6522e7..5cbef91e3 100644
--- a/package/base-files/Makefile
+++ b/package/base-files/Makefile
@@ -41,6 +41,11 @@ define Package/base-files$(TARGET)
This package contains a base filesystem and system scripts for OpenWrt.
URL:=http://openwrt.org/
VERSION:=$(PKG_RELEASE)-$(REV)
+ $(call Config,network.lan.proto,string,static,LAN Protocol)
+ $(call Config,network.lan.ipaddr,ip,192.168.1.1,LAN IP Address)
+ $(call Config,network.lan.netmask,netmask,255.255.0.0,LAN Network Mask)
+ $(call Config,network.lan.gateway,ip,,LAN Gateway)
+ $(call Config,network.lan.dns,ip,,LAN DNS server)
endef
define Package/base-files$(TARGET)/conffiles
@@ -153,3 +158,5 @@ $(eval $(call BuildPackage,base-files$(TARGET)))
$(eval $(call BuildPackage,libgcc))
$(eval $(call BuildPackage,libpthread))
$(eval $(call BuildPackage,uclibc))
+
+
diff --git a/package/base-files/files/bin/firstboot b/package/base-files/files/bin/firstboot
new file mode 100755
index 000000000..fe63d1b27
--- /dev/null
+++ b/package/base-files/files/bin/firstboot
@@ -0,0 +1,128 @@
+#!/bin/sh
+# $Id: firstboot 5544 2006-11-17 03:07:10Z nbd $
+. /etc/functions.sh
+
+partname="rootfs_data"
+mtdpart="$(find_mtd_part $partname)"
+
+rom=$(awk '/squashfs/ {print $2}' /proc/mounts)
+jffs=$(awk '/jffs2/ {print $2}' /proc/mounts)
+
+dupe() { # <new_root> <old_root>
+ cd $1
+ echo -n "creating directories... "
+ {
+ cd $2
+ find . -xdev -type d
+ echo "./dev ./jffs ./mnt ./proc ./tmp"
+ # xdev skips mounted directories
+ cd $1
+ } | xargs mkdir -p
+ echo "done"
+
+ echo -n "setting up symlinks... "
+ for file in $(cd $2; find . -xdev -type f;); do
+ case "$file" in
+ ./rom/note) ;; #nothing
+ ./etc/config*|\
+ ./usr/lib/ipkg/info/*) cp -af $2/$file $file;;
+ *) ln -sf /rom/${file#./*} $file;;
+ esac
+ done
+ for file in $(cd $2; find . -xdev -type l;); do
+ cp -af $2/${file#./*} $file
+ done
+ echo "done"
+}
+
+pivot() { # <new_root> <old_root>
+ mount -o move /proc $1/proc && \
+ pivot_root $1 $1$2 && {
+ mount -o move $2/dev /dev
+ mount -o move $2/tmp /tmp
+ mount -o move $2/jffs /jffs 2>&-
+ return 0
+ }
+}
+
+fopivot() { # <rw_root> <ro_root> <dupe?>
+ root=$1
+ {
+ mount -t mini_fo -o base=/,sto=$1 $1 /mnt 2>&- && root=/mnt
+ } || {
+ [ "$3" = "1" ] && {
+ mount | grep "on $1 type" 2>&- 1>&- || mount -o bind $1 $1
+ dupe $1 $rom
+ }
+ }
+ pivot $root $2
+}
+
+ramoverlay() {
+ mkdir -p /tmp/root
+ fopivot /tmp/root /rom 1
+}
+
+# invoked as an executable
+[ "${0##*/}" = "firstboot" ] && {
+
+ [ -z "$mtdpart" ] && {
+ echo "MTD partition not found."
+ exit 1
+ }
+
+ [ -z "$rom" ] && {
+ echo "You do not have a squashfs partition; aborting"
+ echo "(firstboot cannot be run on jffs2 based firmwares)"
+ exit 1
+ }
+
+ [ "$1" = "switch2jffs" ] && {
+ mtd erase "$partname"
+
+ # try to avoid fs changing while copying
+ mount -o remount,ro none / 2>&-
+
+ # copy ramoverlay to jffs2
+ mount "$mtdpart" /rom/jffs -t jffs2
+ echo -n "copying files ... "
+ cp -a /tmp/root/* /rom/jffs 2>&-
+ echo "done"
+
+ # switch back to squashfs (temporarily)
+ # and park the ramdisk ontop of /tmp/root
+ pivot /rom /mnt
+ mount -o move /mnt /tmp/root
+
+ # /jffs is the overlay
+ # /rom is the readonly
+ fopivot /jffs /rom
+
+ # try to get rid of /tmp/root
+ # this will almost always fail
+ umount /tmp/root 2>&-
+
+ # fs is clean
+ jffs2root --clean
+ exit 0
+ }
+
+ # script run manually
+ [ \! -z "$jffs" ] && {
+ echo "firstboot has already been run"
+ echo "jffs2 partition is mounted, only resetting files"
+ grep mini_fo /proc/filesystems >&-
+ [ $? != 0 ] && {
+ dupe $jffs $rom
+ exit 0
+ } || {
+ rm -rf $jffs/* 2>&-
+ mount -o remount $jffs / 2>&-
+ exit 0
+ }
+ }
+
+ mtd erase "$partname"
+ mount "$mtdpart" /jffs -t jffs2
+ fopivot /jffs /rom 1
+}
diff --git a/package/base-files/files/etc/preinit b/package/base-files/files/etc/preinit
new file mode 100755
index 000000000..74d4e8889
--- /dev/null
+++ b/package/base-files/files/etc/preinit
@@ -0,0 +1,5 @@
+#!/bin/sh
+# Copyright (C) 2006 OpenWrt.org
+export PATH=/bin:/sbin:/usr/bin:/usr/sbin
+mount_root
+exec /sbin/init
diff --git a/package/base-files/files/sbin/mount_root b/package/base-files/files/sbin/mount_root
index 81660f006..607877c64 100755
--- a/package/base-files/files/sbin/mount_root
+++ b/package/base-files/files/sbin/mount_root
@@ -1,10 +1,21 @@
#!/bin/sh
# Copyright (C) 2006 OpenWrt.org
+. /etc/functions.sh
mount none /proc -t proc
size=$(awk '/Mem:/ {l=5242880;print((s=$2/2)<l)?$2-l:s}' /proc/meminfo)
mount none /tmp -t tmpfs -o size=$size,nosuid,nodev,mode=1777
+
+grep rootfs /proc/mtd >/dev/null 2>/dev/null && {
+ mtd unlock rootfs
+ grep rootfs_data /proc/mtd >/dev/null 2>/dev/null && {
+ . /bin/firstboot
+ echo "switching to jffs2"
+ mount "$(find_mtd_part rootfs_data)" /jffs -t jffs2
+ fopivot /jffs /rom
+ }
+} || mount -o remount,rw /dev/root /
+
mkdir -p /dev/pts
mount none /dev/pts -t devpts
-mount -t sysfs none /sys 2>&-
-mount -o remount,rw /dev/root /
+grep sysfs /proc/filesystems >/dev/null && mount -t sysfs none /sys 2>&-